function [y_train, y_test] = Poisson_holdout(y, k, seed)

% Poisson_holdout creates a hold out sample of size k from counts y
% seed: random seed.

s = sum(sum(y));
vy = reshape(y,prod(size(y)),1);
pop = [];
for i=1:length(vy)
    tmp = i*ones(floor(vy(i)),1);
    pop = [pop;tmp];
end
stream = RandStream('mt19937ar','Seed', seed);
RandStream.setGlobalStream(stream);
samp = randsample(pop,k)';

r = zeros(size(vy));
for i=1:length(vy)
    r(i) = sum(samp==i);
end

y_test = reshape(r,size(y));
y_test = min(y, y_test); % to avoid negative y_train when y has fractionals
y_train = y-y_test;


