function lambda_opt = tuneParameters(x, g, eta, P, L, lambda, numTrials, hold_out_ratio)

% Tune regularization parameter lambda by cross validation

% store the negative log likelihood for different lambda's
nLL = zeros(size(lambda)); 

for t = 1:numTrials

    % Split the counts into training and tuning
    [x_train, x_tune] = Poisson_holdout(x, round(sum(x)*hold_out_ratio), t);

    for idx = 1:length(lambda)
        % Solve the optimization problem to estimate f
        f = opt(x_train, g, eta, P, L, lambda(idx));
        % Compute the negative log likelihood
        h = P * eta(f, g);
        nLL(idx) = nLL(idx) + sum(h - x_tune.*log(h));
    end
end
% Select the lambda with largest average tuning likelihood
[~, I] = min(nLL);
lambda_opt = lambda(I);